<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>AdminLTE 3 | Blank Page</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="#" class="nav-link">Contact</a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8"
          />
          <span class="brand-text font-weight-light">Devcamp 120</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Đinh Nhật Toàn</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link active">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Dashboard
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                
                  <li class="nav-item">
                    <a href="searchAll.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>List</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="province.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Province</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="district.html" class="nav-link">
                      <i class="far fa-circle nav-icon"></i>
                      <p>District</p>
                    </a>
                  </li>
                  <li class="nav-item">
                    <a href="ward.html" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Ward</p>
                    </a>
                  </li>
                  
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Ward</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">User</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content text-center">
          <div class="container text-center">
            <h2 class="text-center">Ward</h2>

            <form id="inputform01" class="jumbotron container">
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="nameDistrict">Tên</label>
                </div>
                <div class="col-sm-6">
                  <input type="text" id="input-nameWard" class="form-control" placeholder="Tên phường">
                  
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="ward">Phường xã</label>
                </div>
                <div class="col-sm-6">
                  <select
                    id="ward-select"
                    name="ward"
                    class="form-control"
                  >
                  <option value="Phường">Phường</option>
                  <option value="Xã">Xã</option>
                  <option value="Thị Trấn">Thị Trấn</option>
                </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="province">Tỉnh thành</label>
                </div>
                <div class="col-sm-6">
                  <select
                    id="province-select"
                    name="province"
                    class="form-control"
                  ></select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label for="district">Quận huyện</label>
                </div>
                <div class="col-sm-6">
                  <select
                    id="district-select"
                    disabled
                    name="district"
                    class="form-control"
                  >
                </select>
                </div>
              </div>
              
              <div class="row form-group">
                <div class="col-sm-0">
                  <button id="create-data" class="btn btn-success">Create</button>
                  <button id="update-data" class="btn btn-info">Update</button>
                  <button id="delete-data" class="btn btn-danger">Delete</button>
                  <button id="cancel-data" class="btn btn-warning">Cancel</button>
                </div>
              </div>
              <table class="table table-bordered table-striped table-hover" id="user-table">
                <thead>
                  <tr>
                    <th>STT</th>
                    <th>Mã phường</th>
                    <th>Tên phường</th>
                  </tr>
              </table>
            </form>
          </div>
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 1.0.0</div>
        <strong
          >Copyright &copy; 2023
          <a href="https://adminlte.io">Devcamp 120</a>.</strong
        >
        All rights reserved.
      </footer>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <script>
      "use strict";
      
	    const gBASE_URL ="http://localhost:8080/ward";
      var gObjectWard = [];
	    var vId = 0;

      var table = $("#user-table").DataTable({
        "columns": [
          {"data":"id"},
          {"data":"prefixWard"},
          {"data":"nameWard"},
        ]
      });

      $(document).ready(function(){
        onPageLoading();
        getApiWardAll();

        $('#user-table').on('click', 'tr', function(){
            vId = $(this).find('td:first').text();
            
        });
        
        $('#create-data').on('click', function(){
				var vObj ={
          nameWard:"",
					prefixWard:"",
          district:-1,
				}
				getDataForm(vObj);
				var vIsValidate = validateData(vObj);
				if(vIsValidate){
					getCreateDataApi(vObj);
					resetForm();
				}
       });

       $('#update-data').on('click', function(){
            var vObj ={
              nameWard:"",
              prefixWard:"",
              district:-1,
            }
            getDataForm(vObj);
            getUpdateDataApi(vId, vObj);
            resetForm();
        });

        $('#delete-data').on('click', function(){
          deleteDistrictById(vId);
          resetForm();
        });
      });

      function onPageLoading(){
          //Get data province
        $.ajax({
          url: "http://localhost:8080/province/all",
          method: "GET",
          success: function (pObjRes) {
            console.log(pObjRes);
            loadDataToProvinceSelect(pObjRes);
          },
          error: function (pXhrObj) {
            console.log(pXhrObj);
          },
        });

        var gProvinceSelectElement = $("#province-select");

        function loadDataToProvinceSelect(pProvinceList) {
          for (var i = 0; i < pProvinceList.length; i++) {
            var bProvinceOption = $("<option/>");
            bProvinceOption.prop("value", pProvinceList[i].id);
            bProvinceOption.prop("text", pProvinceList[i].codeProvince);
            gProvinceSelectElement.append(bProvinceOption);
          }
        }

        var gDistrictSelectElement = $("#district-select");

        //callback function
        gProvinceSelectElement.on("change", function () {
          gDistrictSelectElement.html("");
          var bProvinceId = $(this).val();
          console.log(bProvinceId);
          getDistrictByProvinceId(bProvinceId);
        });

        //find brandTypes array by brandId
        function getDistrictByProvinceId(pProvinceId) {
          $.ajax({
            url: "http://localhost:8080/district/search/provinceId=" + pProvinceId,
            method: "GET",
            success: function (pObjRes) {
              console.log(pObjRes);
              loadDataToDistrictSelect(pObjRes);
            },
            error: function (pXhrObj) {
              console.log(pXhrObj);
            },
          });
        }

        function loadDataToDistrictSelect(pDistrictList) {
          if (pDistrictList.length > 0) {
            gDistrictSelectElement.prop("disabled", false);

            for (var i = 0; i < pDistrictList.length; i++) {
              var bDistrictOption = $("<option/>");
              bDistrictOption.prop("value", pDistrictList[i].id);
              bDistrictOption.prop("text", pDistrictList[i].nameDistrict);
              gDistrictSelectElement.append(bDistrictOption);
            }
          } else {
            gDistrictSelectElement.prop("disabled", "disabled");
          }
        }
      }
      
      //Get data province
      function getApiWardAll(){
        $.ajax({
        url: gBASE_URL + "/all",
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          gObjectWard = pObjRes;
          DisplayWardToTable(pObjRes);
        },
        error: function (e) {
          console.log(e.responseText);
        },
      });
      }

      function DisplayWardToTable(paramData) {
        "use strict";
        $("#user-table").DataTable().clear(); // xóa dữ liệu
        $("#user-table").DataTable().rows.add(paramData); //thêm các dòng dữ liệu vào datatable
        $("#user-table").DataTable().draw(); //vẽ lại bảng
      }

      function getDataForm(paramObj){
        paramObj.nameWard = $('#input-nameWard').val();
        paramObj.prefixWard = $('#ward-select').val();
        paramObj.district = $('#district-select').val();        
      }

      function getCreateDataApi(pObject) {
        $.ajax({
          url: gBASE_URL + "/create/" + pObject.district,
          type: "POST",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(pObject),
          success: function(res){
            getApiWardAll();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }

      function resetForm(){
        $('#input-nameWard').val("");
        $('#ward-select').val("");
        $('#district-select').val("");
      }

      function getUpdateDataApi(pId, pObject) {
        $.ajax({
          url: gBASE_URL+ "/update/" + pId,
          type: "PUT",
          contentType: "application/json;charset=UTF-8",
          data: JSON.stringify(pObject),
          success: function(res){
            getApiWardAll();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }

      function validateData(paramObj){
        if(paramObj.nameWard == null){
          alert("Bạn chưa điền tên quận!");
          return false;
        }
        if(paramObj.prefixWard == null){
          alert("Bạn chưa điền mã prefix quận!");
          return false;
        }
        return true;
      }

      function deleteDistrictById(pId) {
        $.ajax({
          url: gBASE_URL + "/delete/" + pId,
          type: "DELETE",
          async: false,
          success: function (paramOrderRes) {
            getApiWardAll();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          },
        });
      }
    </script>
  </body>
</html>
